<template>
  <v-row>
    <v-col cols="12">
      <v-expansion-panels popout multiple>
        <v-expansion-panel v-for="(item, i) in items" :key="i">
          <v-expansion-panel-header>
            <v-row>
              <v-col cols="2" md="1">
                <v-icon color="primary">{{ icons.mapMarker }}</v-icon>
              </v-col>
              <v-col cols="8">
                {{ item[0].pointAddress }}
              </v-col>
            </v-row>
          </v-expansion-panel-header>
          <v-expansion-panel-content>
            <v-data-table
              hide-default-footer
              class="reduced"
              item-key="orderItemId"
              :headers="headers"
              :items="item"
              :items-per-page="-1"
            >
              <template v-slot:item.expiration="{ item }">{{
                item.expiration | expiration
              }}</template>

              <template v-slot:item.price="{ item }">
                <v-layout justify-end>{{ item.price }}</v-layout>
              </template>

              <template v-slot:item.quantity="{ item }">
                <v-edit-dialog :return-value="item.quantity" lazy>
                  <v-layout justify-end>{{ item.quantity }}</v-layout>
                  <template v-slot:input>
                    <v-text-field
                      :value="item.quantity"
                      label="Количество"
                      single-line
                      autofocus
                      clearable
                      type="number"
                      min="0"
                      @change="(value) => saveQuantity(item, value)"
                    ></v-text-field>
                  </template>
                </v-edit-dialog>
              </template>

              <template v-slot:item.actions="{ item }">
                <v-icon small @click="saveQuantity(item, 0)">
                  {{ icons.delete }}
                </v-icon>
              </template>

              <template v-slot:no-data>
                <v-alert :value="true" type="warning"
                  >Записи не найдены</v-alert
                >
              </template>
            </v-data-table>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </v-col>
  </v-row>
</template>

<script>
import { Icon } from "@/helpers";

export default {
  props: {
    order: Object,
  },
  computed: {
    items: function () {
      return this.order && this.order.items
        ? this.order.items.reduce((previousValue, currentItem) => {
            previousValue[currentItem.pointId] =
              previousValue[currentItem.pointId] || [];
            previousValue[currentItem.pointId].push(currentItem);
            return previousValue;
          }, Object.create(null))
        : null;
    },
  },
  methods: {
    saveQuantity: function (item, value) {
      if (value == null || value == "") value = 0;
      let currentItem = Object.assign({}, item);
      currentItem.quantity = value;
      this.$emit("update-quantity", currentItem);
    },
  },
  data: () => ({
    search: "",
    headers: [
      { text: "Наименование", value: "productName" },
      { text: "Производитель", value: "manufacturer" },
      { text: "Страна", value: "productCountry" },
      { text: "Срок годности", value: "expiration", align: "center" },
      { text: "Цена", value: "price", align: "right", width: "9%" },
      { text: "Количество", value: "quantity", align: "right" },
      { text: "", value: "actions" },
    ],
    icons: {
      mapMarker: Icon.mapMarker,
      delete: Icon.delete,
    },
  }),
  mounted: function () {},
};
</script>
